Whamcloud - gitweb
LU-11634 tests: sanityn/test_77 improvements
[fs/lustre-release.git] / lustre / tests / sanityn.sh
index f5c7fe5..a3d505d 100755 (executable)
@@ -3,8 +3,9 @@
 set -e
 
 ONLY=${ONLY:-"$*"}
-# bug number for skipped test: LU-1205 9977/LU-7105 LU-9452
-ALWAYS_EXCEPT="                18c     28           29      $SANITYN_EXCEPT"
+# bug number for skipped test: 9977/LU-7105
+#              LU-7105
+ALWAYS_EXCEPT=" 28     $SANITYN_EXCEPT"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
 SRCDIR=$(dirname $0)
@@ -33,8 +34,8 @@ init_test_env $@
 init_logging
 
 if [ $(facet_fstype $SINGLEMDS) = "zfs" ]; then
-# bug number for skipped test:        LU-2776
-       ALWAYS_EXCEPT="$ALWAYS_EXCEPT 51a"
+# bug number for skipped test:
+       ALWAYS_EXCEPT="$ALWAYS_EXCEPT "
 # LU-2829 / LU-2887 - make allowances for ZFS slowness
        TEST33_NFILES=${TEST33_NFILES:-1000}
 fi
@@ -48,6 +49,8 @@ TRACE=${TRACE:-""}
 
 check_and_setup_lustre
 
+OSC=${OSC:-"osc"}
+
 assert_DIR
 rm -rf $DIR1/[df][0-9]* $DIR1/lnk $DIR/[df].${TESTSUITE}*
 
@@ -82,7 +85,8 @@ test_2a() {
        touch $DIR1/f2a
        ls -l $DIR2/f2a
        chmod 777 $DIR2/f2a
-       $CHECKSTAT -t file -p 0777 $DIR1/f2a || error
+       $CHECKSTAT -t file -p 0777 $DIR1/f2a ||
+               error "Either not file type or perms not 0777"
 }
 run_test 2a "check cached attribute updates on 2 mtpt's ========"
 
@@ -90,20 +94,23 @@ test_2b() {
        touch $DIR1/f2b
        ls -l $DIR2/f2b
        chmod 777 $DIR1/f2b
-       $CHECKSTAT -t file -p 0777 $DIR2/f2b || error
+       $CHECKSTAT -t file -p 0777 $DIR2/f2b ||
+               error "Either not file type or perms not 0777"
 }
 run_test 2b "check cached attribute updates on 2 mtpt's ========"
 
 # NEED TO SAVE ROOT DIR MODE
 test_2c() {
        chmod 777 $DIR1
-       $CHECKSTAT -t dir -p 0777 $DIR2 || error
+       $CHECKSTAT -t dir -p 0777 $DIR2 ||
+               error "Either not dir type or perms not 0777"
 }
 run_test 2c "check cached attribute updates on 2 mtpt's root ==="
 
 test_2d() {
        chmod 755 $DIR1
-       $CHECKSTAT -t dir -p 0755 $DIR2 || error
+       $CHECKSTAT -t dir -p 0755 $DIR2 ||
+               error "Either not file type or perms not 0775"
 }
 run_test 2d "check cached attribute updates on 2 mtpt's root ==="
 
@@ -112,7 +119,8 @@ test_2e() {
         ls -l $DIR1
         ls -l $DIR2
         chmod 777 $DIR1
-        $RUNAS dd if=/dev/zero of=$DIR2/$tfile count=1 || error
+               $RUNAS dd if=/dev/zero of=$DIR2/$tfile count=1 ||
+                       error "dd failed"
 }
 run_test 2e "check chmod on root is propagated to others"
 
@@ -159,7 +167,7 @@ test_2g() {
        local block2=$(stat $DIR2/$tfile | awk '/Blocks/ {print $4} ')
        echo "$DIR1/$tfile has $block1 blocks"
        echo "$DIR2/$tfile has $block2 blocks"
-       [ $block1 -eq $block2 ] || error
+       [ $block1 -eq $block2 ] || error "$block1 not equal to $block2"
 }
 run_test 2g "check blocks update on sync write"
 
@@ -179,7 +187,8 @@ run_test 4 "fstat validation on multiple mount points =========="
 test_5() {
        mcreate $DIR1/f5
        $TRUNCATE $DIR2/f5 100
-       $CHECKSTAT -t file -s 100 $DIR1/f5 || error
+       $CHECKSTAT -t file -s 100 $DIR1/f5 ||
+               error "Either not file type or size not equal to 100 bytes"
        rm $DIR1/f5
 }
 run_test 5 "create a file on one mount, truncate it on the other"
@@ -203,7 +212,7 @@ test_8() {
 }
 run_test 8 "remove of open special file on other node =========="
 
-test_9() {
+test_9a() {
        MTPT=1
        local dir
        > $DIR2/f9
@@ -215,7 +224,23 @@ test_9() {
        [ "`cat $DIR1/f9`" = "abcdefghijkl" ] || \
                error "`od -a $DIR1/f9` != abcdefghijkl"
 }
-run_test 9 "append of file with sub-page size on multiple mounts"
+run_test 9a "append of file with sub-page size on multiple mounts"
+
+#LU-10681 - tiny writes & appending to sparse striped file
+test_9b() {
+       [[ $OSTCOUNT -ge 2 ]] || { skip "needs >= 2 OSTs"; return; }
+
+       $LFS setstripe -c 2 -S 1M $DIR/$tfile
+       echo "foo" >> $DIR/$tfile
+       dd if=/dev/zero of=$DIR2/$tfile bs=1M count=1 seek=1 conv=notrunc ||
+               error "sparse dd $DIR2/$tfile failed"
+       echo "foo" >> $DIR/$tfile
+
+       data=$(dd if=$DIR2/$tfile bs=1 count=3 skip=$((2 * 1048576)) conv=notrunc)
+       echo "Data read (expecting 'foo')": $data
+       [ "$data" = "foo" ] || error "append to sparse striped file failed"
+}
+run_test 9b "append to striped sparse file"
 
 test_10a() {
        MTPT=1
@@ -258,34 +283,34 @@ test_11() {
        $DIR2/d11/f
        RC=$?
        kill -USR1 $MULTIPID
-       wait $MULTIPID || error
+       wait $MULTIPID || error "wait for PID $MULTIPID failed"
        [ $RC -eq 0 ] && error || true
 }
 run_test 11 "execution of file opened for write should return error ===="
 
 test_12() {
-       DIR=$DIR DIR2=$DIR2 sh lockorder.sh
+       DIR=$DIR DIR2=$DIR2 sh lockorder.sh
 }
-run_test 12 "test lock ordering (link, stat, unlink) ==========="
+run_test 12 "test lock ordering (link, stat, unlink)"
 
 test_13() {    # bug 2451 - directory coherency
-       test_mkdir $DIR1/d13 || error
-       cd $DIR1/d13 || error
-       ls
-       ( touch $DIR1/d13/f13 ) # needs to be a separate shell
-       ls
-       rm -f $DIR2/d13/f13 || error
-       ls 2>&1 | grep f13 && error "f13 shouldn't return an error (1)" || true
-       # need to run it twice
-       ( touch $DIR1/d13/f13 ) # needs to be a separate shell
-       ls
-       rm -f $DIR2/d13/f13 || error
-       ls 2>&1 | grep f13 && error "f13 shouldn't return an error (2)" || true
-}
-run_test 13 "test directory page revocation ===================="
+       test_mkdir $DIR1/d13
+       cd $DIR1/d13 || error "cd to $DIR1/d13 failed"
+       ls
+       ( touch $DIR1/d13/f13 ) # needs to be a separate shell
+       ls
+       rm -f $DIR2/d13/f13 || error "Cannot remove $DIR2/d13/f13"
+       ls 2>&1 | grep f13 && error "f13 shouldn't return an error (1)" || true
+       # need to run it twice
+       ( touch $DIR1/d13/f13 ) # needs to be a separate shell
+       ls
+       rm -f $DIR2/d13/f13 || error "Cannot remove $DIR2/d13/f13"
+       ls 2>&1 | grep f13 && error "f13 shouldn't return an error (2)" || true
+}
+run_test 13 "test directory page revocation"
 
 test_14aa() {
-       test_mkdir -p $DIR1/$tdir
+       test_mkdir $DIR1/$tdir
        cp -p /bin/ls $DIR1/$tdir/$tfile
        multiop_bg_pause $DIR1/$tdir/$tfile Ow_c || return 1
        MULTIPID=$!
@@ -297,55 +322,59 @@ test_14aa() {
 run_test 14aa "execution of file open for write returns -ETXTBSY"
 
 test_14ab() {
-       test_mkdir -p $DIR1/d14
-       cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
-        MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
-        MULTIOP_PID=$!
-        $MULTIOP $DIR2/d14/multiop Oc && error "expected error, got success"
-        kill -USR1 $MULTIOP_PID || return 2
-        wait $MULTIOP_PID || return 3
-        rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
+       test_mkdir $DIR1/$tdir
+       cp -p $(which multiop) $DIR1/$tdir/multiop || error "cp failed"
+       MULTIOP_PROG=$DIR1/$tdir/multiop multiop_bg_pause $TMP/$tfile O_c ||
+               return 1
+       MULTIOP_PID=$!
+       $MULTIOP $DIR2/$tdir/multiop Oc && error "expected error, got success"
+       kill -USR1 $MULTIOP_PID || return 2
+       wait $MULTIOP_PID || return 3
+       rm $TMP/$tfile $DIR1/$tdir/multiop || error "removing multiop"
 }
 run_test 14ab "open(RDWR) of executing file returns -ETXTBSY"
 
 test_14b() { # bug 3192, 7040
-       test_mkdir -p $DIR1/d14
-       cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
-        MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
-        MULTIOP_PID=$!
-        $TRUNCATE $DIR2/d14/multiop 0 && kill -9 $MULTIOP_PID && \
+       test_mkdir $DIR1/$tdir
+       cp -p $(which multiop) $DIR1/$tdir/multiop || error "cp failed"
+       MULTIOP_PROG=$DIR1/$tdir/multiop multiop_bg_pause $TMP/$tfile O_c ||
+               return 1
+       MULTIOP_PID=$!
+       $TRUNCATE $DIR2/$tdir/multiop 0 && kill -9 $MULTIOP_PID && \
                error "expected truncate error, got success"
-        kill -USR1 $MULTIOP_PID || return 2
-        wait $MULTIOP_PID || return 3
-       cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
-       rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
+       kill -USR1 $MULTIOP_PID || return 2
+       wait $MULTIOP_PID || return 3
+       cmp $(which multiop) $DIR1/$tdir/multiop || error "binary changed"
+       rm $TMP/$tfile $DIR1/$tdir/multiop || error "removing multiop"
 }
 run_test 14b "truncate of executing file returns -ETXTBSY ======"
 
 test_14c() { # bug 3430, 7040
-       test_mkdir -p $DIR1/d14
-       cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
-       MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
-        MULTIOP_PID=$!
-       cp /etc/hosts $DIR2/d14/multiop && error "expected error, got success"
+       test_mkdir $DIR1/$tdir
+       cp -p $(which multiop) $DIR1/$tdir/multiop || error "cp failed"
+       MULTIOP_PROG=$DIR1/$tdir/multiop multiop_bg_pause $TMP/$tfile O_c ||
+               return 1
+       MULTIOP_PID=$!
+       cp /etc/hosts $DIR2/$tdir/multiop && error "expected error, got success"
        kill -USR1 $MULTIOP_PID || return 2
        wait $MULTIOP_PID || return 3
-       cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
-       rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
+       cmp $(which multiop) $DIR1/$tdir/multiop || error "binary changed"
+       rm $TMP/$tfile $DIR1/$tdir/multiop || error "removing multiop"
 }
 run_test 14c "open(O_TRUNC) of executing file return -ETXTBSY =="
 
 test_14d() { # bug 10921
-       test_mkdir -p $DIR1/d14
-       cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
-       MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
-        MULTIOP_PID=$!
+       test_mkdir $DIR1/$tdir
+       cp -p $(which multiop) $DIR1/$tdir/multiop || error "cp failed"
+       MULTIOP_PROG=$DIR1/$tdir/multiop multiop_bg_pause $TMP/$tfile O_c ||
+               return 1
+       MULTIOP_PID=$!
        log chmod
-       chmod 600 $DIR1/d14/multiop || error "chmod failed"
+       chmod 600 $DIR1/$tdir/multiop || error "chmod failed"
        kill -USR1 $MULTIOP_PID || return 2
        wait $MULTIOP_PID || return 3
-       cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
-       rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
+       cmp $(which multiop) $DIR1/$tdir/multiop || error "binary changed"
+       rm $TMP/$tfile $DIR1/$tdir/multiop || error "removing multiop"
 }
 run_test 14d "chmod of executing file is still possible ========"
 
@@ -373,7 +402,31 @@ else
        FSXP=100
 fi
 
-test_16() {
+test_16a() {
+       local file1=$DIR1/$tfile
+       local file2=$DIR2/$tfile
+       local stripe_size=$(do_facet $SINGLEMDS \
+               "$LCTL get_param -n lod.$(facet_svc $SINGLEMDS)*.stripesize")
+
+       # to allocate grant because it may run out due to test_15.
+       $LFS setstripe -c -1 $file1
+       dd if=/dev/zero of=$file1 bs=$stripe_size count=$OSTCOUNT oflag=sync
+       dd if=/dev/zero of=$file2 bs=$stripe_size count=$OSTCOUNT oflag=sync
+       rm -f $file1
+
+       $LFS setstripe -c -1 $file1 # b=10919
+       fsx -c 50 -p $FSXP -N $FSXNUM -l $((SIZE * 256)) -S 0 $file1 $file2 \
+               || error "fsx failed"
+       rm -f $file1
+
+       # O_DIRECT reads and writes must be aligned to the device block size.
+       fsx -c 50 -p $FSXP -N $FSXNUM -l $((SIZE * 256)) -S 0 -Z -r 4096 \
+               -w 4096 $file1 $file2 || error "fsx with O_DIRECT failed."
+}
+run_test 16a "$FSXNUM iterations of dual-mount fsx"
+
+# Consistency check for tiny writes, LU-9409
+test_16b() {
        local file1=$DIR1/$tfile
        local file2=$DIR2/$tfile
 
@@ -384,9 +437,48 @@ test_16() {
        rm -f $file1
 
        lfs setstripe -c -1 $file1 # b=10919
-       fsx -c 50 -p $FSXP -N $FSXNUM -l $((SIZE * 256)) -S 0 $file1 $file2
+       # -o is set to 8192 because writes < 1 page and between 1 and 2 pages
+       # create a mix of tiny writes & normal writes
+       fsx -c 50 -p $FSXP -N $FSXNUM -l $((SIZE * 256)) -o 8192 -S 0 $file1 \
+       $file2
+}
+run_test 16b "$FSXNUM iterations of dual-mount fsx at small size"
+
+test_16c() {
+       local file1=$DIR1/$tfile
+       local file2=$DIR2/$tfile
+       local stripe_size=$(do_facet $SINGLEMDS \
+               "$LCTL get_param -n lod.$(facet_svc $SINGLEMDS)*.stripesize")
+
+       [ $(facet_fstype ost1) != ldiskfs ] && skip "dio on ldiskfs only"
+
+       # to allocate grant because it may run out due to test_15.
+       $LFS setstripe -c -1 $file1
+       dd if=/dev/zero of=$file1 bs=$stripe_size count=$OSTCOUNT oflag=sync
+       dd if=/dev/zero of=$file2 bs=$stripe_size count=$OSTCOUNT oflag=sync
+       rm -f $file1
+       wait_delete_completed
+
+       local list=$(comma_list $(osts_nodes))
+       if ! get_osd_param $list '' read_cache_enable >/dev/null; then
+               skip "not cache-capable obdfilter"
+       fi
+
+       set_osd_param $list '' read_cache_enable 0
+       set_osd_param $list '' writethrough_cache_enable 0
+
+       $LFS setstripe -c -1 $file1 # b=10919
+       fsx -c 50 -p $FSXP -N $FSXNUM -l $((SIZE * 256)) -S 0 $file1 $file2 \
+               || error "fsx failed"
+       rm -f $file1
+
+       set_osd_param $list '' read_cache_enable 1
+       set_osd_param $list '' writethrough_cache_enable 1
+
+       return 0
 }
-run_test 16 "$FSXNUM iterations of dual-mount fsx"
+run_test 16c "verify data consistency on ldiskfs with cache disabled (b=17397)"
+
 
 test_17() { # bug 3513, 3667
        remote_ost_nodsh && skip "remote OST with nodsh" && return
@@ -422,21 +514,20 @@ run_test 18 "mmap sanity check ================================="
 test_19() { # bug3811
        local node=$(facet_active_host ost1)
 
+       [ "x$DOM" = "xyes" ] && node=$(facet_active_host $SINGLEMDS)
+
        # check whether obdfilter is cache capable at all
-       if ! get_osd_param $node '' read_cache_enable >/dev/null; then
-               echo "not cache-capable obdfilter"
-               return 0
-       fi
+       get_osd_param $node '' read_cache_enable >/dev/null ||
+               skip "not cache-capable obdfilter"
 
-       local MAX=$(get_osd_param $node '' readcache_max_filesize | \
-                   head -n 1)
+       local MAX=$(get_osd_param $node '' readcache_max_filesize | head -n 1)
        set_osd_param $node '' readcache_max_filesize 4096
        dd if=/dev/urandom of=$TMP/$tfile bs=512k count=32
        local SUM=$(cksum $TMP/$tfile | cut -d" " -f 1,2)
        cp $TMP/$tfile $DIR1/$tfile
        for i in `seq 1 20`; do
                [ $((i % 5)) -eq 0 ] && log "$testname loop $i"
-               cancel_lru_locks osc > /dev/null
+               cancel_lru_locks $OSC > /dev/null
                cksum $DIR1/$tfile | cut -d" " -f 1,2 > $TMP/sum1 & \
                cksum $DIR2/$tfile | cut -d" " -f 1,2 > $TMP/sum2
                wait
@@ -452,12 +543,12 @@ run_test 19 "test concurrent uncached read races ==============="
 
 test_20() {
        test_mkdir $DIR1/d20
-       cancel_lru_locks osc
+       cancel_lru_locks $OSC
        CNT=$((`lctl get_param -n llite.*.dump_page_cache | wc -l`))
        $MULTIOP $DIR1/f20 Ow8190c
        $MULTIOP $DIR2/f20 Oz8194w8190c
        $MULTIOP $DIR1/f20 Oz0r8190c
-       cancel_lru_locks osc
+       cancel_lru_locks $OSC
        CNTD=$((`lctl get_param -n llite.*.dump_page_cache | wc -l` - $CNT))
        [ $CNTD -gt 0 ] && \
            error $CNTD" page left in cache after lock cancel" || true
@@ -488,7 +579,7 @@ test_23() { # Bug 5972
        echo "atime should be updated while another read" > $DIR1/$tfile
 
        # clear the lock(mode: LCK_PW) gotten from creating operation
-       cancel_lru_locks osc
+       cancel_lru_locks $OSC
        time1=$(date +%s)
        echo "now is $time1"
        sleep $((at_diff + 1))
@@ -520,9 +611,9 @@ test_24a() {
 
        OSC=`lctl dl | awk '/-osc-|OSC.*MNT/ {print $4}' | head -n 1`
 #      OSC=`lctl dl | awk '/-osc-/ {print $4}' | head -n 1`
-       lctl --device %$OSC deactivate
+       lctl --device %osc deactivate
        lfs df -i || error "lfs df -i with deactivated OSC failed"
-       lctl --device %$OSC activate
+       lctl --device %osc activate
        lfs df || error "lfs df with reactivated OSC failed"
 }
 run_test 24a "lfs df [-ih] [path] test ========================="
@@ -592,7 +683,7 @@ test_25b() {
 run_test 25b "change ACL under remote dir on one mountpoint be seen on another"
 
 test_26a() {
-        utime $DIR1/f26a -s $DIR2/f26a || error
+       utime $DIR1/f26a -s $DIR2/f26a || error "utime failed for $DIR1/f26a"
 }
 run_test 26a "allow mtime to get older"
 
@@ -612,7 +703,7 @@ test_26b() {
 run_test 26b "sync mtime between ost and mds"
 
 test_27() {
-       cancel_lru_locks osc
+       cancel_lru_locks $OSC
        lctl clear
        dd if=/dev/zero of=$DIR2/$tfile bs=$((4096+4))k conv=notrunc count=4 seek=3 &
        DD2_PID=$!
@@ -656,46 +747,33 @@ test_28() { # bug 9977
        EOF
 
        # reading of 1st stripe should pass
-       dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 || error
+       dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 || error "dd failed"
        # reading of 2nd stripe should fail (this stripe was destroyed)
        dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 skip=1 && error
 
        # now, recreating test file
-       dd if=/dev/zero of=$DIR1/$tfile bs=1024k count=2 || error
+       dd if=/dev/zero of=$DIR1/$tfile bs=1024k count=2 || error "dd failed"
        # reading of 1st stripe should pass
-       dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 || error
+       dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 || error "dd failed"
        # reading of 2nd stripe should pass
-       dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 skip=1 || error
+       dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 skip=1 ||
+               error "dd failed"
 }
 run_test 28 "read/write/truncate file with lost stripes"
 
-test_29() { # bug 10999
-       touch $DIR1/$tfile
-       #define OBD_FAIL_LDLM_GLIMPSE  0x30f
-       lctl set_param fail_loc=0x8000030f
-       ls -l $DIR2/$tfile &
-       usleep 500
-       dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1
-       wait
-}
-#bug 11549 - permanently turn test off in b1_5
-run_test 29 "lock put race between glimpse and enqueue ========="
-
-test_30() { #bug #11110, LU-2523
-       test_mkdir -p $DIR1/$tdir
+test_30() { #b=11110, LU-2523
+       test_mkdir $DIR1/$tdir
        cp -f /bin/bash $DIR1/$tdir/bash
-       /bin/sh -c 'sleep 1; rm -f $DIR2/$tdir/bash;
-                   cp /bin/bash $DIR2/$tdir' &
+       /bin/sh -c 'sleep 1; rm -f $DIR2/$tdir/bash; cp /bin/bash $DIR2/$tdir' &
        $DIR1/$tdir/bash -c 'sleep 2;
                openfile -f O_RDONLY /proc/$$/exe >& /dev/null; echo $?'
        wait
        true
 }
-
 run_test 30 "recreate file race"
 
 test_31a() {
-       test_mkdir -p $DIR1/$tdir || error "Creating dir $DIR1/$tdir"
+       test_mkdir $DIR1/$tdir
        local writes=$(LANG=C dd if=/dev/zero of=$DIR/$tdir/$tfile \
                       count=1 2>&1 | awk 'BEGIN { FS="+" } /out/ {print $1}')
        #define OBD_FAIL_LDLM_CANCEL_BL_CB_RACE   0x314
@@ -714,7 +792,7 @@ test_31b() {
        wait_mds_ost_sync || error "wait_mds_ost_sync()"
        wait_delete_completed || error "wait_delete_completed()"
 
-       test_mkdir -p $DIR1/$tdir || error "Creating dir $DIR1/$tdir"
+       test_mkdir $DIR1/$tdir
         lfs setstripe $DIR/$tdir/$tfile -i 0 -c 1
         cp /etc/hosts $DIR/$tdir/$tfile
         #define OBD_FAIL_LDLM_CANCEL_BL_CB_RACE   0x314
@@ -732,43 +810,45 @@ run_test 31b "voluntary OST cancel / blocking ast race=============="
 
 # enable/disable lockless truncate feature, depending on the arg 0/1
 enable_lockless_truncate() {
-        lctl set_param -n osc.*.lockless_truncate $1
+       lctl set_param -n $OSC.*.lockless_truncate $1
 }
 
 test_32a() { # bug 11270
-       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
-       save_lustre_params client "osc.*.lockless_truncate" > $p
-       cancel_lru_locks osc
+       local save="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       local stripe_size=$(do_facet $SINGLEMDS \
+               "$LCTL get_param -n lod.$(facet_svc $SINGLEMDS)*.stripesize")
+
+       save_lustre_params client "$OSC.*.lockless_truncate" > $save
+       # restore lockless_truncate default values on exit
+       stack_trap "restore_lustre_params < $save; rm -f $save" EXIT
+       cancel_lru_locks $OSC
        enable_lockless_truncate 1
        rm -f $DIR1/$tfile
        lfs setstripe -c -1 $DIR1/$tfile
-       dd if=/dev/zero of=$DIR1/$tfile count=$OSTCOUNT bs=$STRIPE_BYTES > \
+       dd if=/dev/zero of=$DIR1/$tfile count=$OSTCOUNT bs=$stripe_size > \
                /dev/null 2>&1
-       clear_stats osc.*.osc_stats
+       clear_stats $OSC.*.${OSC}_stats
 
        log "checking cached lockless truncate"
        $TRUNCATE $DIR1/$tfile 8000000
        $CHECKSTAT -s 8000000 $DIR2/$tfile || error "wrong file size"
-       [ $(calc_stats osc.*.osc_stats lockless_truncate) -ne 0 ] ||
+       [ $(calc_stats $OSC.*.${OSC}_stats lockless_truncate) -ne 0 ] ||
                error "cached truncate isn't lockless"
 
        log "checking not cached lockless truncate"
        $TRUNCATE $DIR2/$tfile 5000000
        $CHECKSTAT -s 5000000 $DIR1/$tfile || error "wrong file size"
-       [ $(calc_stats osc.*.osc_stats lockless_truncate) -ne 0 ] ||
+       [ $(calc_stats $OSC.*.${OSC}_stats lockless_truncate) -ne 0 ] ||
                error "not cached truncate isn't lockless"
 
        log "disabled lockless truncate"
        enable_lockless_truncate 0
-       clear_stats osc.*.osc_stats
+       clear_stats $OSC.*.${OSC}_stats
        $TRUNCATE $DIR2/$tfile 3000000
        $CHECKSTAT -s 3000000 $DIR1/$tfile || error "wrong file size"
-       [ $(calc_stats osc.*.osc_stats lockless_truncate) -eq 0 ] ||
+       [ $(calc_stats $OSC.*.${OSC}_stats lockless_truncate) -eq 0 ] ||
                error "lockless truncate disabling failed"
-       rm $DIR1/$tfile
-       # restore lockless_truncate default values
-       restore_lustre_params < $p
-       rm -f $p
+       rm -f $DIR1/$tfile
 }
 run_test 32a "lockless truncate"
 
@@ -786,21 +866,21 @@ test_32b() { # bug 11270
                "ldlm.namespaces.filter-*.contended_locks" >> $p
        save_lustre_params $facets \
                "ldlm.namespaces.filter-*.contention_seconds" >> $p
-       clear_stats osc.*.osc_stats
+       clear_stats $OSC.*.${OSC}_stats
 
        # agressive lockless i/o settings
        do_nodes $(comma_list $(osts_nodes)) \
                "lctl set_param -n ldlm.namespaces.*.max_nolock_bytes=2000000 \
                        ldlm.namespaces.filter-*.contended_locks=0 \
                        ldlm.namespaces.filter-*.contention_seconds=60"
-       lctl set_param -n osc.*.contention_seconds=60
+       lctl set_param -n $OSC.*.contention_seconds=60
        for i in {1..5}; do
                dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1 conv=notrunc > \
                        /dev/null 2>&1
                dd if=/dev/zero of=$DIR2/$tfile bs=4k count=1 conv=notrunc > \
                        /dev/null 2>&1
        done
-       [ $(calc_stats osc.*.osc_stats lockless_write_bytes) -ne 0 ] ||
+       [ $(calc_stats $OSC.*.${OSC}_stats lockless_write_bytes) -ne 0 ] ||
                error "lockless i/o was not triggered"
        # disable lockless i/o (it is disabled by default)
        do_nodes $(comma_list $(osts_nodes)) \
@@ -809,15 +889,15 @@ test_32b() { # bug 11270
                        ldlm.namespaces.filter-*.contention_seconds=0"
        # set contention_seconds to 0 at client too, otherwise Lustre still
        # remembers lock contention
-       lctl set_param -n osc.*.contention_seconds=0
-       clear_stats osc.*.osc_stats
+       lctl set_param -n $OSC.*.contention_seconds=0
+       clear_stats $OSC.*.${OSC}_stats
        for i in {1..1}; do
                dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1 conv=notrunc > \
                        /dev/null 2>&1
                dd if=/dev/zero of=$DIR2/$tfile bs=4k count=1 conv=notrunc > \
                        /dev/null 2>&1
        done
-       [ $(calc_stats osc.*.osc_stats lockless_write_bytes) -eq 0 ] ||
+       [ $(calc_stats $OSC.*.${OSC}_stats lockless_write_bytes) -eq 0 ] ||
                error "lockless i/o works when disabled"
        rm -f $DIR1/$tfile
        restore_lustre_params <$p
@@ -960,39 +1040,57 @@ test_33c() {
        [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.63) ] &&
                skip "DNE CoS not supported" && return
 
-       sync
+       local sync_count
 
        mkdir $DIR/$tdir
-       # remote mkdir is done on MDT2, which enqueued lock of $tdir on MDT1
-       $LFS mkdir -i 1 $DIR/$tdir/d1
+       sync_all_data
        do_facet mds1 "lctl set_param -n mdt.*.sync_count=0"
-       mkdir $DIR/$tdir/d2
-       local sync_count=$(do_facet mds1 \
-               "lctl get_param -n mdt.*MDT0000.sync_count")
-       [ $sync_count -eq 1 ] || error "Sync-Lock-Cancel not triggered"
+       # do twice in case transaction is committed before unlock, see LU-8200
+       for i in 1 2; do
+               # remote dir is created on MDT1, which enqueued lock of $tdir on
+               # MDT0
+               $LFS mkdir -i 1 $DIR/$tdir/remote.$i
+               mkdir $DIR/$tdir/local.$i
+       done
+       sync_count=$(do_facet mds1 "lctl get_param -n mdt.*MDT0000.sync_count")
+       echo "sync_count $sync_count"
+       [ $sync_count -eq 0 ] && error "Sync-Lock-Cancel not triggered"
 
-       $LFS mkdir -i 1 $DIR/$tdir/d3
+       sync_all_data
        do_facet mds1 "lctl set_param -n mdt.*.sync_count=0"
+       $LFS mkdir -i 1 $DIR/$tdir/remote.3
        # during sleep remote mkdir should have been committed and canceled
        # remote lock spontaneously, which shouldn't trigger sync
        sleep 6
-       mkdir $DIR/$tdir/d4
-       local sync_count=$(do_facet mds1 \
-               "lctl get_param -n mdt.*MDT0000.sync_count")
+       mkdir $DIR/$tdir/local.3
+       sync_count=$(do_facet mds1 "lctl get_param -n mdt.*MDT0000.sync_count")
+       echo "sync_count $sync_count"
        [ $sync_count -eq 0 ] || error "Sync-Lock-Cancel triggered"
 }
 run_test 33c "Cancel cross-MDT lock should trigger Sync-Lock-Cancel"
 
-ops_do_cos() {
+# arg1 is operations done before CoS, arg2 is the operation that triggers CoS
+op_trigger_cos() {
+       local commit_nr
+       local total=0
        local nodes=$(comma_list $(mdts_nodes))
-       do_nodes $nodes "lctl set_param -n mdt.*.async_commit_count=0"
-       sh -c "$@"
-       local async_commit_count=$(do_nodes $nodes \
-               "lctl get_param -n mdt.*.async_commit_count" | calc_sum)
-       [ $async_commit_count -gt 0 ] || error "CoS not triggerred"
 
-       rm -rf $DIR/$tdir
-       sync
+       sync_all_data
+
+       # trigger CoS twice in case transaction commit before unlock
+       for i in 1 2; do
+               sh -c "$1"
+               do_nodes $nodes "lctl set_param -n mdt.*.async_commit_count=0"
+               sh -c "$2"
+               commit_nr=$(do_nodes $nodes \
+                       "lctl get_param -n mdt.*.async_commit_count" | calc_sum)
+               total=$((total + commit_nr));
+               rm -rf $DIR/$tdir
+               sync_all_data
+       done
+
+       echo "CoS count $total"
+       [ $total -gt 0 ] || error "$2 didn't trigger CoS"
 }
 
 test_33d() {
@@ -1000,39 +1098,34 @@ test_33d() {
        [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.63) ] &&
                skip "DNE CoS not supported" && return
 
-       sync
        # remote directory create
-       mkdir $DIR/$tdir
-       ops_do_cos "$LFS mkdir -i 1 $DIR/$tdir/subdir"
+       op_trigger_cos "mkdir $DIR/$tdir" "$LFS mkdir -i 1 $DIR/$tdir/subdir"
        # remote directory unlink
-       $LFS mkdir -i 1 $DIR/$tdir
-       ops_do_cos "rmdir $DIR/$tdir"
+       op_trigger_cos "$LFS mkdir -i 1 $DIR/$tdir" "rmdir $DIR/$tdir"
        # striped directory create
-       mkdir $DIR/$tdir
-       ops_do_cos "$LFS mkdir -c 2 $DIR/$tdir/subdir"
+       op_trigger_cos "mkdir $DIR/$tdir" "$LFS mkdir -c 2 $DIR/$tdir/subdir"
        # striped directory setattr
-       $LFS mkdir -c 2 $DIR/$tdir
-       touch $DIR/$tdir
-       ops_do_cos "chmod 713 $DIR/$tdir"
+       op_trigger_cos "$LFS mkdir -c 2 $DIR/$tdir; touch $DIR/$tdir" \
+               "chmod 713 $DIR/$tdir"
        # striped directory unlink
-       $LFS mkdir -c 2 $DIR/$tdir
-       touch $DIR/$tdir
-       ops_do_cos "rmdir $DIR/$tdir"
+       op_trigger_cos "$LFS mkdir -c 2 $DIR/$tdir; touch $DIR/$tdir" \
+               "rmdir $DIR/$tdir"
        # cross-MDT link
-       $LFS mkdir -c 2 $DIR/$tdir
-       $LFS mkdir -i 0 $DIR/$tdir/d1
-       $LFS mkdir -i 1 $DIR/$tdir/d2
-       touch $DIR/$tdir/d1/tgt
-       ops_do_cos "ln $DIR/$tdir/d1/tgt $DIR/$tdir/d2/src"
+       op_trigger_cos "$LFS mkdir -c 2 $DIR/$tdir; \
+                       $LFS mkdir -i 0 $DIR/$tdir/d1; \
+                       $LFS mkdir -i 1 $DIR/$tdir/d2; \
+                       touch $DIR/$tdir/d1/tgt" \
+               "ln $DIR/$tdir/d1/tgt $DIR/$tdir/d2/src"
        # cross-MDT rename
-       $LFS mkdir -c 2 $DIR/$tdir
-       $LFS mkdir -i 0 $DIR/$tdir/d1
-       $LFS mkdir -i 1 $DIR/$tdir/d2
-       touch $DIR/$tdir/d1/src
-       ops_do_cos "mv $DIR/$tdir/d1/src $DIR/$tdir/d2/tgt"
+       op_trigger_cos "$LFS mkdir -c 2 $DIR/$tdir; \
+                       $LFS mkdir -i 0 $DIR/$tdir/d1; \
+                       $LFS mkdir -i 1 $DIR/$tdir/d2; \
+                       touch $DIR/$tdir/d1/src" \
+               "mv $DIR/$tdir/d1/src $DIR/$tdir/d2/tgt"
        # migrate
-       $LFS mkdir -i 0 $DIR/$tdir
-       ops_do_cos "$LFS migrate -m 1 $DIR/$tdir"
+       op_trigger_cos "$LFS mkdir -i 0 $DIR/$tdir" \
+               "$LFS migrate -m 1 $DIR/$tdir"
+
        return 0
 }
 run_test 33d "DNE distributed operation should trigger COS"
@@ -1084,7 +1177,7 @@ cleanup_34() {
        do_nodes $(comma_list $(osts_nodes)) \
                "lctl set_param -n fail_loc=0 2>/dev/null || true"
        for i in $(seq $OSTCOUNT); do
-               wait_osc_import_state client ost$i FULL
+               wait_osc_import_ready client ost$i
        done
 }
 
@@ -1137,52 +1230,54 @@ test_34() { #16129
 run_test 34 "no lock timeout under IO"
 
 test_35() { # bug 17645
-        local generation=[]
-        local count=0
+       local generation=[]
+       local count=0
        gen=$(lctl get_param mdc.$FSNAME-MDT*-mdc-*.import | grep generation |
-               awk '/generation/{print $2}')
+             awk '/generation/{print $2}')
        for g in $gen; do
-            generation[count]=$g
-            let count=count+1
-        done
+               generation[count]=$g
+               let count=count+1
+       done
 
-       test_mkdir -p $MOUNT1/$tfile
-        cancel_lru_locks mdc
+       test_mkdir $MOUNT1/$tdir
+       cancel_lru_locks mdc
 
-        # Let's initiate -EINTR situation by setting fail_loc and take
-        # write lock on same file from same client. This will not cause
-        # bl_ast yet as lock is already in local cache.
-#define OBD_FAIL_LDLM_INTR_CP_AST        0x317
-        do_facet client "lctl set_param fail_loc=0x80000317"
-        local timeout=`do_facet $SINGLEMDS lctl get_param  -n timeout`
-        let timeout=timeout*3
-        local nr=0
-        while test $nr -lt 10; do
-                log "Race attempt $nr"
-                local blk1=`lctl get_param -n ldlm.services.ldlm_cbd.stats | awk '/ldlm_bl_callback/ {print $2}'`
-                test "x$blk1" = "x" && blk1=0
-                createmany -o $MOUNT2/$tfile/a 4000 &
-                pid1=$!
-                sleep 1
-
-                # Let's make conflict and bl_ast
-                ls -la $MOUNT1/$tfile > /dev/null &
-                pid2=$!
-
-                log "Wait for $pid1 $pid2 for $timeout sec..."
-                sleep $timeout
-                kill -9 $pid1 $pid2 > /dev/null 2>&1
-                wait
-                local blk2=`lctl get_param -n ldlm.services.ldlm_cbd.stats | awk '/ldlm_bl_callback/ {print $2}'`
-                test "x$blk2" = "x" && blk2=0
-                test $blk2 -gt $blk1 && break
-                rm -fr $MOUNT1/$tfile/*
-                cancel_lru_locks mdc
-                let nr=nr+1
-        done
-        do_facet client "lctl set_param fail_loc=0x0"
-        df -h $MOUNT1 $MOUNT2
-        count=0
+       # Let's initiate -EINTR situation by setting fail_loc and take
+       # write lock on same file from same client. This will not cause
+       # bl_ast yet as lock is already in local cache.
+       #define OBD_FAIL_LDLM_INTR_CP_AST        0x317
+       do_facet client "lctl set_param fail_loc=0x80000317"
+       local timeout=$(do_facet $SINGLEMDS lctl get_param  -n timeout)
+       let timeout=timeout*3
+       local nr=0
+       while test $nr -lt 10; do
+               log "Race attempt $nr"
+               local blk1=$(lctl get_param -n ldlm.services.ldlm_cbd.stats |
+                            awk '/ldlm_bl_callback/ { print $2 }')
+               test "x$blk1" = "x" && blk1=0
+               createmany -o $MOUNT2/$tdir/a 4000 &
+               pid1=$!
+               sleep 1
+
+               # Let's make conflict and bl_ast
+               ls -la $MOUNT1/$tdir > /dev/null &
+               pid2=$!
+
+               log "Wait for $pid1 $pid2 for $timeout sec..."
+               sleep $timeout
+               kill -9 $pid1 $pid2 > /dev/null 2>&1
+               wait
+               local blk2=$(lctl get_param -n ldlm.services.ldlm_cbd.stats |
+                            awk '/ldlm_bl_callback/ { print $2 }')
+               test "x$blk2" = "x" && blk2=0
+               test $blk2 -gt $blk1 && break
+               rm -fr $MOUNT1/$tdir
+               cancel_lru_locks mdc
+               let nr=nr+1
+       done
+       do_facet client "lctl set_param fail_loc=0x0"
+       df -h $MOUNT1 $MOUNT2
+       count=0
        gen=$(lctl get_param mdc.$FSNAME-MDT*-mdc-*.import | grep generation |
                awk '/generation/{print $2}')
        for g in $gen; do
@@ -1208,7 +1303,7 @@ test_36() { #bug 16417
        local SIZE_B
        local i
 
-       test_mkdir -p $DIR1/$tdir
+       test_mkdir $DIR1/$tdir
        $LFS setstripe -c -1 $DIR1/$tdir
        i=0
        SIZE=50
@@ -1245,7 +1340,7 @@ test_36() { #bug 16417
 run_test 36 "handle ESTALE/open-unlink correctly"
 
 test_37() { # bug 18695
-       test_mkdir -p $DIR1/$tdir
+       test_mkdir $DIR1/$tdir
        multiop_bg_pause $DIR1/$tdir D_c || return 1
        MULTIPID=$!
        # create large directory (32kB seems enough from e2fsck, ~= 1000 files)
@@ -1369,7 +1464,7 @@ test_39d() { # LU-7310
 
        $LCTL set_param fail_loc=0
 
-       cancel_lru_locks osc
+       cancel_lru_locks $OSC
 
        local mtime2=$(stat -c %Y $DIR2/$tfile)
        [ "$mtime2" -ge "$d1" ] && [ "$mtime2" -le "$d2" ] ||
@@ -2380,11 +2475,13 @@ run_test 47f "pdirops: remote mkdir and rename (src)"
 
 test_47g() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       sync
+       sync_all_data
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
        $LFS mkdir -i 1 $DIR1/$tfile &
        PID1=$!
-       sleep 1
+       sleep 2
        stat $DIR2/$tfile > /dev/null || error "stat must succeed"
        check_pdo_conflict $PID1 && { wait $PID1;
                                        error "getattr isn't blocked"; }
@@ -2428,7 +2525,10 @@ test_51a() {
                error "dd $DIR1/$tfile failed"
 
        # MULTIOP proc should be able to read enough bytes and exit
-       sleep 2
+       for ((i = 0; i < 6; i++)); do
+               sleep 1
+               kill -0 $pid || break
+       done
        kill -0 $pid 2> /dev/null && error "multiop is still there"
        cmp $origfile $DIR2/$tfile || error "$origfile and $DIR2/$tfile differs"
 
@@ -2466,7 +2566,7 @@ test_51b() {
 run_test 51b "layout lock: glimpse should be able to restart if layout changed"
 
 test_51c() {
-       [ $OSTCOUNT -ge 2 ] || { skip "need at least 2 osts"; return; }
+       [ $OSTCOUNT -ge 2 ] || { skip "needs >= 2 osts"; return; }
 
        # set default layout to have 1 stripe
        mkdir $DIR1/$tdir
@@ -2487,14 +2587,14 @@ test_51c() {
 
        # write something to the file, it should be blocked on fetching layout
        dd if=/dev/zero of=$DIR2/$tdir/$tfile bs=1k count=1 conv=notrunc
-       local stripecnt=$($LFS getstripe -c $DIR2/$tdir/$tfile)
+       local stripe_count=$($LFS getstripe -c $DIR2/$tdir/$tfile)
        wait $pid
 
        # lod_qos.c::min_stripe_count() allows setstripe with a default stripe
        # count to succeed with only 3/4 of the number of stripes (rounded up),
        # so creating striped files does not fail if an OST is offline or full
-       [ $stripecnt -ge $((OSTCOUNT - $OSTCOUNT / 4)) ] ||
-               error "layout wrong: getstripe -c $stripecnt < $OSTCOUNT * 3/4"
+       [ $stripe_count -ge $((OSTCOUNT - $OSTCOUNT / 4)) ] ||
+               error "bad layout: getstripe -c $stripe_count < $OSTCOUNT * 3/4"
 
        rm -fr $DIR1/$tdir
 }
@@ -2513,14 +2613,14 @@ test_51d() {
        local br=$(grep -A 10 $tfile /proc/$PID/smaps | awk '/^Rss/{print $2}')
        echo "Before revoking layout lock: $br KB mapped"
 
-       # delete the file will revoke layout lock
-       rm -f $DIR2/$tfile
+       # cancel layout lock manually
+       cancel_lru_locks mdc
 
        # rss after revoking
        local ar=$(grep -A 10 $tfile /proc/$PID/smaps | awk '/^Rss/{print $2}')
 
        kill -USR1 $PID
-       wait $PID || error
+       wait $PID || error "wait PID $PID failed"
 
        [ $ar -eq 0 ] || error "rss before: $br, after $ar, some pages remained"
 }
@@ -2684,7 +2784,7 @@ test_60() {
                skip "MDS version $MDSVER must be >= 2.3.0" && return 0
 
        # Create a file
-       test_mkdir -p $DIR1/$tdir
+       test_mkdir $DIR1/$tdir
        file1=$DIR1/$tdir/file
        file2=$DIR2/$tdir/file
 
@@ -2782,7 +2882,7 @@ test_71a() {
                { skip "checkfiemap not runnable: $?" && return; }
        # write data this way: hole - data - hole - data
        dd if=/dev/urandom of=$DIR1/$tfile bs=40K seek=1 count=1
-       [ "$(facet_fstype ost$(($($GETSTRIPE -i $DIR1/$tfile) + 1)))" = \
+       [ "$(facet_fstype ost$(($($LFS getstripe -i $DIR1/$tfile) + 1)))" = \
                "zfs" ] &&
                skip "ORI-366/LU-1941: FIEMAP unimplemented on ZFS" && return 0
        dd if=/dev/urandom of=$DIR1/$tfile bs=40K seek=3 count=1
@@ -2821,7 +2921,7 @@ test_71b() {
        [[ $server_version -lt $(version_code 2.4.0) ]] &&
                skip "Need MDS version earlier than 2.2.0 or at least 2.4.0" &&
                        return
-       [[ $OSTCOUNT -ge 2 ]] || { skip "need at least 2 osts"; return; }
+       [[ $OSTCOUNT -ge 2 ]] || { skip "needs >= 2 OSTs"; return; }
 
        checkfiemap --test ||
                { skip "error $?: checkfiemap failed" && return; }
@@ -2830,7 +2930,7 @@ test_71b() {
 
        $LFS setstripe -c -1 $DIR1/$tdir || error "setstripe failed"
        dd if=/dev/urandom of=$DIR1/$tdir/$tfile bs=40K count=1
-       [ "$(facet_fstype ost$(($($GETSTRIPE -i $DIR1/$tdir/$tfile) + 1)))" = \
+       [ "$(facet_fstype ost$(($($LFS getstripe -i $DIR1/$tdir/$tfile) + 1)))" = \
                "zfs" ] &&
                skip "ORI-366/LU-1941: FIEMAP unimplemented on ZFS" && return 0
        checkfiemap $DIR1/$tdir/$tfile 40960 || error "checkfiemap failed"
@@ -2945,7 +3045,7 @@ test_76() { #LU-946
        fi
 
        rm -rf $DIR/$tdir
-       test_mkdir -p $DIR/$tdir
+       test_mkdir $DIR/$tdir
 
        # drop all open locks and close any cached "open" files on the client
        cancel_lru_locks mdc
@@ -3023,36 +3123,57 @@ nrs_write_read() {
        chmod 777 $dir
 
        do_nodes $CLIENTS $myRUNAS \
-               dd if=/dev/zero of="$dir/nrs_r_$HOSTNAME" bs=1M count=$n ||
+               dd if=/dev/zero of="$dir/nrs_r_\$HOSTNAME" bs=1M count=$n ||
                error "dd at 0 on client failed (1)"
 
-       for ((i = 0; i < $n; i++)); do
-               do_nodes $CLIENTS $myRUNAS dd if=/dev/zero \
-                       of="$dir/nrs_w_$HOSTNAME" bs=1M seek=$i count=1 ||
-                        error "dd at ${i}MB on client failed (2)" &
-               local pids_w[$i]=$!
-       done
+       do_nodes $CLIENTS $myRUNAS \
+               "declare -a pids_w;
+               for ((i = 0; i < $n; i++)); do
+                       dd if=/dev/zero of=$dir/nrs_w_\$HOSTNAME bs=1M \
+seek=\\\$i count=1 conv=notrunc &
+                       pids_w[\\\$i]=\\\$!;
+               done;
+               rc_w=0;
+               for ((i = 0; i < $n; i++)); do
+                       wait \\\${pids_w[\\\$i]};
+                       newrc=\\\$?;
+                       [ \\\$newrc -gt \\\$rc_w ] && rc_w=\\\$newrc;
+               done;
+               exit \\\$rc_w" &
+       local pid_w=$!
        do_nodes $CLIENTS sync;
        cancel_lru_locks osc
 
-       for ((i = 0; i < $n; i++)); do
-               do_nodes $CLIENTS $myRUNAS dd if="$dir/nrs_w_$HOSTNAME" \
-                       of=/dev/zero bs=1M seek=$i count=1 > /dev/null ||
-                       error "dd at ${i}MB on client failed (3)" &
-               local pids_r[$i]=$!
-       done
+       do_nodes $CLIENTS $myRUNAS \
+               "declare -a pids_r;
+               for ((i = 0; i < $n; i++)); do
+                       dd if=$dir/nrs_r_\$HOSTNAME bs=1M of=/dev/null \
+seek=\\\$i count=1 &
+                       pids_r[\\\$i]=\\\$!;
+               done;
+               rc_r=0;
+               for ((i = 0; i < $n; i++)); do
+                       wait \\\${pids_r[\\\$i]};
+                       newrc=\\\$?;
+                       [ \\\$newrc -gt \\\$rc_r ] && rc_r=\\\$newrc;
+               done;
+               exit \\\$rc_r" &
+       local pid_r=$!
        cancel_lru_locks osc
 
-       for ((i = 0; i < $n; i++)); do
-               wait ${pids_w[$i]}
-               wait ${pids_r[$i]}
-       done
-       rm -rf $dir || error "rm -rf $dir failed"
+       wait $pid_w || error "dd (write) failed (2)"
+       wait $pid_r || error "dd (read) failed (3)"
+       rm -rvf $dir || error "rm -rf $dir failed"
 }
 
 test_77a() { #LU-3266
+       local rc
+
        oss=$(comma_list $(osts_nodes))
-       do_nodes $oss lctl set_param ost.OSS.*.nrs_policies="fifo"
+       do_nodes $oss lctl set_param ost.OSS.*.nrs_policies="fifo" ||
+               rc=$?
+       [[ $rc -eq 3 ]] && skip "no NRS exists" && return
+       [[ $rc -ne 0 ]] && error "failed to set fifo policy"
        nrs_write_read
 
        return 0
@@ -3060,21 +3181,29 @@ test_77a() { #LU-3266
 run_test 77a "check FIFO NRS policy"
 
 test_77b() { #LU-3266
+       local rc
+
        oss=$(comma_list $(osts_nodes))
 
        do_nodes $oss lctl set_param ost.OSS.*.nrs_policies="crrn" \
-                          ost.OSS.*.nrs_crrn_quantum=1
+               ost.OSS.*.nrs_crrn_quantum=1 || rc=$?
+       [[ $rc -eq 3 ]] && skip "no NRS exists" && return
+       [[ $rc -ne 0 ]] && error "failed to set crrn_quantum to 1"
 
        echo "policy: crr-n, crrn_quantum 1"
        nrs_write_read
 
-       do_nodes $oss lctl set_param ost.OSS.*.nrs_crrn_quantum=64
+       do_nodes $oss lctl set_param \
+               ost.OSS.*.nrs_crrn_quantum=64 || rc=$?
+       [[ $rc -ne 0 ]] && error "failed to set crrn_quantum to 64"
 
        echo "policy: crr-n, crrn_quantum 64"
        nrs_write_read
 
        # cleanup
-       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="fifo"
+       do_nodes $oss lctl set_param \
+               ost.OSS.ost_io.nrs_policies="fifo" || rc=$?
+       [[ $rc -ne 0 ]] && error "failed to set fifo policy"
        return 0
 }
 run_test 77b "check CRR-N NRS policy"
@@ -3085,37 +3214,49 @@ orr_trr() {
        oss=$(comma_list $(osts_nodes))
 
        do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies=$policy \
-                                    ost.OSS.*.nrs_"$policy"_quantum=1 \
-                                    ost.OSS.*.nrs_"$policy"_offset_type="physical" \
-                                    ost.OSS.*.nrs_"$policy"_supported="reads"
+               ost.OSS.*.nrs_"$policy"_quantum=1 \
+               ost.OSS.*.nrs_"$policy"_offset_type="physical" \
+               ost.OSS.*.nrs_"$policy"_supported="reads" || return $?
 
-       echo "policy: $policy, ${policy}_quantum 1, ${policy}_offset_type physical, ${policy}_supported reads"
+       echo "policy: $policy, ${policy}_quantum 1, ${policy}_offset_type " \
+               "physical, ${policy}_supported reads"
        nrs_write_read
 
-       do_nodes $oss lctl set_param ost.OSS.*.nrs_${policy}_supported="writes" \
-                                    ost.OSS.*.nrs_${policy}_quantum=64
+       do_nodes $oss lctl set_param \
+               ost.OSS.*.nrs_${policy}_supported="writes" \
+               ost.OSS.*.nrs_${policy}_quantum=64 || return $?
 
-       echo "policy: $policy, ${policy}_quantum 64, ${policy}_offset_type physical, ${policy}_supported writes"
+       echo "policy: $policy, ${policy}_quantum 64, ${policy}_offset_type " \
+               "physical, ${policy}_supported writes"
        nrs_write_read
 
-       do_nodes $oss lctl set_param ost.OSS.*.nrs_${policy}_supported="reads_and_writes" \
-                                    ost.OSS.*.nrs_${policy}_offset_type="logical"
-       echo "policy: $policy, ${policy}_quantum 64, ${policy}_offset_type logical, ${policy}_supported reads_and_writes"
+       do_nodes $oss lctl set_param \
+               ost.OSS.*.nrs_${policy}_supported="reads_and_writes" \
+               ost.OSS.*.nrs_${policy}_offset_type="logical" || return $?
+       echo "policy: $policy, ${policy}_quantum 64, ${policy}_offset_type " \
+               "logical, ${policy}_supported reads_and_writes"
        nrs_write_read
 
        # cleanup
-       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="fifo"
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="fifo" ||
+               return $?
        return 0
 }
 
 test_77c() { #LU-3266
-       orr_trr "orr"
+       local rc
+       orr_trr "orr" || rc=$?
+       [[ $rc -eq 3 ]] && skip "no NRS exists" && return
+       [[ $rc -ne 0 ]] && error "orr_trr failed rc:$rc"
        return 0
 }
 run_test 77c "check ORR NRS policy"
 
 test_77d() { #LU-3266
-       orr_trr "trr"
+       local rc
+       orr_trr "trr" || rc=$?
+       [[ $rc -eq 3 ]] && skip "no NRS exists" && return
+       [[ $rc -ne 0 ]] && error "orr_trr failed rc:$rc"
        return 0
 }
 run_test 77d "check TRR nrs policy"
@@ -3147,47 +3288,55 @@ tbf_verify() {
        local client1=${CLIENT1:-$(hostname)}
        local myRUNAS="$3"
 
+       local np=$(check_cpt_number ost1)
+       [ $np -gt 0 ] || error "CPU partitions should not be $np."
+       echo "cpu_npartitions on ost1 is $np"
+
        mkdir $dir || error "mkdir $dir failed"
-       $LFS setstripe -c 1 $dir || error "setstripe to $dir failed"
+       $LFS setstripe -c 1 -i 0 $dir || error "setstripe to $dir failed"
        chmod 777 $dir
 
        trap cleanup_tbf_verify EXIT
        echo "Limited write rate: $1, read rate: $2"
        echo "Verify the write rate is under TBF control"
-       local runtime=$(do_node $client1 $myRUNAS dd if=/dev/zero of=$dir/tbf \
-               bs=1M count=100 oflag=direct 2>&1 | awk '/bytes/ {print $6}')
+       local start=$SECONDS
+       do_node $client1 $myRUNAS dd if=/dev/zero of=$dir/tbf \
+               bs=1M count=100 oflag=direct 2>&1
+       local runtime=$((SECONDS - start + 1))
        local rate=$(bc <<< "scale=6; 100 / $runtime")
        echo "Write runtime is $runtime s, speed is $rate IOPS"
 
-       # verify the write rate does not exceed 110% of TBF limited rate
-       [ $(bc <<< "$rate < 1.1 * $1") -eq 1 ] ||
-               error "The write rate ($rate) exceeds 110% of preset rate ($1)"
+       # verify the write rate does not exceed TBF rate limit
+       [ $(bc <<< "$rate < 1.1 * $np * $1") -eq 1 ] ||
+               error "The write rate ($rate) exceeds 110% of rate limit ($1 * $np)"
 
        cancel_lru_locks osc
 
        echo "Verify the read rate is under TBF control"
-       runtime=$(do_node $client1 $myRUNAS dd if=$dir/tbf of=/dev/null \
-               bs=1M count=100 iflag=direct 2>&1 | awk '/bytes/ {print $6}')
+       start=$SECONDS
+       do_node $client1 $myRUNAS dd if=$dir/tbf of=/dev/null \
+               bs=1M count=100 iflag=direct 2>&1
+       runtime=$((SECONDS - start + 1))
        rate=$(bc <<< "scale=6; 100 / $runtime")
        echo "Read runtime is $runtime s, speed is $rate IOPS"
 
-       # verify the read rate does not exceed 110% of TBF limited rate
-       [ $(bc <<< "$rate < 1.1 * $2") -eq 1 ] ||
-               error "The read rate ($rate) exceeds 110% of preset rate ($2)"
+       # verify the read rate does not exceed TBF rate limit
+       [ $(bc <<< "$rate < 1.1 * $np * $2") -eq 1 ] ||
+               error "The read rate ($rate) exceeds 110% of rate limit ($2 * $np)"
 
        cancel_lru_locks osc
        cleanup_tbf_verify || error "rm -rf $dir failed"
 }
 
 test_77e() {
-       local server_version=$(lustre_version_code ost1)
-       [[ $server_version -ge $(version_code 2.7.58) ]] ||
-               { skip "Need server version newer than 2.7.57"; return 0; }
+       local rc
 
        oss=$(comma_list $(osts_nodes))
 
-       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="tbf\ nid"
-       [ $? -ne 0 ] && error "failed to set TBF policy"
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="tbf\ nid" ||
+               rc=$?
+       [[ $rc -eq 3 ]] && skip "no NRS TBF exists" && return
+       [[ $rc -ne 0 ]] && error "failed to set TBF NID policy"
 
        local idis
        local rateis
@@ -3226,23 +3375,25 @@ test_77e() {
 run_test 77e "check TBF NID nrs policy"
 
 test_77f() {
-       local server_version=$(lustre_version_code ost1)
-       [[ $server_version -ge $(version_code 2.7.58) ]] ||
-               { skip "Need server version newer than 2.7.57"; return 0; }
+       local rc
 
        oss=$(comma_list $(osts_nodes))
 
+       do_nodes $oss $LCTL set_param \
+               ost.OSS.ost_io.nrs_policies="tbf\ jobid" || rc=$?
+       [[ $rc -eq 3 ]] && skip "no NRS TBF exists" && return
+       [[ $rc -ne 0 ]] && error "failed to set TBF JOBID policy"
+
        # Configure jobid_var
        local saved_jobid_var=$($LCTL get_param -n jobid_var)
+       rc=$?
+       [[ $rc -eq 3 ]] && skip "jobid_var not found" && return
+       [[ $rc -ne 0 ]] && error "failed to get param jobid_var"
        if [ $saved_jobid_var != procname_uid ]; then
-               set_conf_param_and_check client                 \
-                       "$LCTL get_param -n jobid_var"          \
-                       "$FSNAME.sys.jobid_var" procname_uid
+               set_persistent_param_and_check client \
+                       "jobid_var" "$FSNAME.sys.jobid_var" procname_uid
        fi
 
-       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="tbf\ jobid"
-       [ $? -ne 0 ] && error "failed to set TBF policy"
-
        local idis
        local rateis
        if [ $(lustre_version_code ost1) -ge $(version_code 2.8.54) ]; then
@@ -3275,27 +3426,28 @@ test_77f() {
        nrs_write_read "$RUNAS"
 
        local current_jobid_var=$($LCTL get_param -n jobid_var)
+       [[ $? -ne 0 ]] && error "failed to get param jobid_var"
        if [ $saved_jobid_var != $current_jobid_var ]; then
-               set_conf_param_and_check client                 \
-                       "$LCTL get_param -n jobid_var"          \
-                       "$FSNAME.sys.jobid_var" $saved_jobid_var
+               set_persistent_param_and_check client \
+                       "jobid_var" "$FSNAME.sys.jobid_var" $saved_jobid_var
        fi
        return 0
 }
 run_test 77f "check TBF JobID nrs policy"
 
 test_77g() {
-       local server_version=$(lustre_version_code ost1)
-       [[ $server_version -ge $(version_code 2.7.58) ]] ||
-               { skip "Need server version newer than 2.7.57"; return 0; }
+       local rc=0
 
        oss=$(comma_list $(osts_nodes))
 
-       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="tbf\ nid"
-       [ $? -ne 0 ] && error "failed to set TBF policy"
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="tbf\ nid" ||
+               rc=$?
+       [[ $rc -eq 3 ]] && skip "no NRS TBF exists" && return
+       [[ $rc -ne 0 ]] && error "failed to set TBF NID policy"
 
-       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="tbf\ jobid"
-       [ $? -ne 0 ] && error "failed to set TBF policy"
+       do_nodes $oss lctl set_param \
+               ost.OSS.ost_io.nrs_policies="tbf\ jobid" || rc=$?
+       [[ $rc -ne 0 ]] && error "failed to set TBF JOBID policy"
 
        local idis
        local rateis
@@ -3371,7 +3523,7 @@ tbf_rule_check()
 }
 
 test_77i() {
-    [ $(lustre_version_code ost1) -ge $(version_code 2.8.55) ] ||
+       [ $(lustre_version_code ost1) -ge $(version_code 2.8.55) ] ||
                { skip "Need OST version at least 2.8.55"; return 0; }
 
        for i in $(seq 1 $OSTCOUNT)
@@ -3426,7 +3578,11 @@ run_test 77i "Change rank of TBF rule"
 test_77j() {
        local idis
        local rateis
-       if [ $(lustre_version_code ost1) -ge $(version_code 2.8.60) ]; then
+       local ost_version=$(lustre_version_code ost1)
+
+       [ $ost_version -ge $(version_code 2.9.53) ] ||
+               { skip "Need OST version at least 2.9.53"; return 0; }
+       if [ $ost_version -ge $(version_code 2.8.60) ]; then
                idis="opcode="
                rateis="rate="
        fi
@@ -3453,6 +3609,57 @@ test_77j() {
 }
 run_test 77j "check TBF-OPCode NRS policy"
 
+test_id() {
+       local idstr="${1}id"
+       local policy="${idstr}={$2}"
+       local rate="rate=$3"
+
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param jobid_var=procname_uid \
+                       ost.OSS.ost_io.nrs_policies="tbf\ ${idstr}" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ost_${idstr}\ ${policy}\ ${rate}"
+       [ $? -ne 0 ] && error "failed to set tbf ${idstr} policy"
+
+       nrs_write_read "runas $4"
+       tbf_verify $3 $3 "runas $4"
+
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param ost.OSS.ost_io.nrs_tbf_rule="stop\ ost_${idstr}" \
+                       ost.OSS.ost_io.nrs_policies="fifo"
+
+       # sleep 3 seconds to wait the tbf policy stop completely,
+       # or the next test case is possible get -eagain when
+       # setting the tbf policy
+       sleep 3
+}
+
+test_77ja(){
+       if [ $(lustre_version_code ost1) -lt $(version_code 2.11.50) ]; then
+               skip "Need OST version at least 2.11.50"
+               return 0
+       fi
+       test_id "u" "500" "5" "-u 500"
+       test_id "g" "500" "5" "-u 500 -g 500"
+}
+run_test 77ja "check TBF-UID/GID NRS policy"
+
+cleanup_77k()
+{
+       local rule_lists=$1
+       local old_nrs=$2
+
+       trap 0
+       for rule in $rule_lists; do
+               do_nodes $(comma_list $(osts_nodes)) \
+                       lctl set_param ost.OSS.ost_io.nrs_tbf_rule="stop\ $rule"
+       done
+
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param ost.OSS.ost_io.nrs_policies="$old_nrs"
+
+       sleep 3
+}
+
 test_77k() {
        [[ $(lustre_version_code ost1) -ge $(version_code 2.9.53) ]] ||
                { skip "Need OST version at least 2.9.53"; return 0; }
@@ -3495,16 +3702,59 @@ test_77k() {
        tbf_verify 10 10 "$RUNAS"
        tbf_verify 20 10
 
+       trap "cleanup_77k \"ext_a ext_b\" \"fifo\"" EXIT
+
+       [[ $(lustre_version_code ost1) -ge $(version_code 2.10.58) ]] ||
+               { skip "Need OST version at least 2.10.58"; return 0; }
+
        do_nodes $(comma_list $(osts_nodes)) \
                lctl set_param ost.OSS.ost_io.nrs_tbf_rule="stop\ ext_a" \
                        ost.OSS.ost_io.nrs_tbf_rule="stop\ ext_b" \
-                       ost.OSS.ost_io.nrs_policies="fifo"
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ext_ug\ uid={500}\&gid={1000}\ rate=5"
+       nrs_write_read "runas -u 500 -g 1000"
+       tbf_verify 5 5 "runas -u 500 -g 1000"
 
-       sleep 3
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param ost.OSS.ost_io.nrs_tbf_rule="stop\ ext_ug" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ext_uw\ uid={500}\&opcode={ost_write}\ rate=20" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ext_ur\ uid={500}\&opcode={ost_read}\ rate=10"
+
+       nrs_write_read "runas -u 500"
+       tbf_verify 20 10 "runas -u 500"
+
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param ost.OSS.ost_io.nrs_tbf_rule="stop\ ext_uw" \
+                       ost.OSS.ost_io.nrs_tbf_rule="stop\ ext_ur" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ext_a\ uid={500},opcode={ost_write}\ rate=20" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ext_b\ uid={500},opcode={ost_read}\ rate=10"
+       nrs_write_read "runas -u 500"
+       tbf_verify 10 10 "runas -u 500"
+       tbf_verify 20 10 "runas -u 500"
+       cleanup_77k "ext_a ext_b" "fifo"
 }
-run_test 77k "check the extended TBF policy with NID/JobID/OPCode expression"
+run_test 77k "check TBF policy with NID/JobID/OPCode expression"
 
 test_77l() {
+       [[ $(lustre_version_code ost1) -ge $(version_code 2.10.56) ]] ||
+               { skip "Need OST version at least 2.10.56"; return 0; }
+
+       do_facet ost1 lctl set_param ost.OSS.ost_io.nrs_policies="tbf\ nid"
+       do_facet ost1 lctl set_param ost.OSS.ost_io.nrs_policies="tbf"
+
+       local output=$(do_facet ost1 lctl get_param \
+                       ost.OSS.ost_io.nrs_policies | \
+                       awk '/name: tbf/ {print;exit}' | \
+                       awk -F ': ' '{print $2}')
+
+       if [ "$output" != "tbf" ]; then
+               error "The generic TBF output is '$output', not 'tbf'"
+       fi
+
+       do_facet ost1 lctl set_param ost.OSS.ost_io.nrs_policies="fifo"
+}
+run_test 77l "check the output of NRS policies for generic TBF"
+
+test_77m() {
        if [ $(lustre_version_code ost1) -lt $(version_code 2.9.54) ]; then
                skip "Need OST version at least 2.9.54"
                return 0
@@ -3554,19 +3804,58 @@ test_77l() {
 
        return 0
 }
-run_test 77l "check NRS Delay slows write RPC processing"
+run_test 77m "check NRS Delay slows write RPC processing"
 
-test_78() { #LU-6673
-       local server_version=$(lustre_version_code ost1)
-       [[ $server_version -ge $(version_code 2.7.58) ]] ||
-               { skip "Need server version newer than 2.7.57"; return 0; }
+test_77n() { #LU-10802
+       if [ $(lustre_version_code ost1) -lt $(version_code 2.10.58) ]; then
+               skip "Need OST version at least 2.10.58"
+               return 0
+       fi
+
+       # Configure jobid_var
+       local saved_jobid_var=$($LCTL get_param -n jobid_var)
+       if [ $saved_jobid_var != procname_uid ]; then
+               set_persistent_param_and_check client \
+                       "jobid_var" "$FSNAME.sys.jobid_var" procname_uid
+       fi
+
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param ost.OSS.ost_io.nrs_policies="tbf\ jobid" \
+                       ost.OSS.ost_io.nrs_tbf_rule="stop\ dd_runas" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ dd_runas\ jobid={*.$RUNAS_ID}\ rate=20"
+
+       nrs_write_read
+       tbf_verify 20 20 "$RUNAS"
 
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param ost.OSS.ost_io.nrs_tbf_rule="stop\ dd_runas" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ dd_runas\ jobid={dd.*}\ rate=20"
+
+       nrs_write_read
+       tbf_verify 20 20
+
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param ost.OSS.ost_io.nrs_tbf_rule="stop\ dd_runas" \
+                       ost.OSS.ost_io.nrs_policies="fifo"
+
+       sleep 3
+
+       local current_jobid_var=$($LCTL get_param -n jobid_var)
+       if [ $saved_jobid_var != $current_jobid_var ]; then
+               set_persistent_param_and_check client \
+                       "jobid_var" "$FSNAME.sys.jobid_var" $saved_jobid_var
+       fi
+}
+run_test 77n "check wildcard support for TBF JobID NRS policy"
+
+test_78() { #LU-6673
        local rc
 
        oss=$(comma_list $(osts_nodes))
        do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="orr" &
        do_nodes $oss lctl set_param ost.OSS.*.nrs_orr_quantum=1
        rc=$?
+       [[ $rc -eq 3 ]] && skip "no NRS exists" && return
        # Valid return codes are:
        # 0: Tuning succeeded
        # ENODEV: Policy is still stopped
@@ -3583,7 +3872,7 @@ run_test 78 "Enable policy and specify tunings right away"
 
 test_79() {
        remote_mds_nodsh && skip "remote MDS with nodsh" && return
-       test_mkdir -p $DIR/$tdir
+       test_mkdir $DIR/$tdir
 
        # Prevent interference from layout intent RPCs due to
        # asynchronous writeback. These will be tested in 130c below.
@@ -3593,7 +3882,7 @@ test_79() {
                error "setfattr -n trusted.name1=value1 $DIR/$tdir failed"
 
 #define OBD_FAIL_MDS_INTENT_DELAY              0x160
-       local mdtidx=$($LFS getstripe -M $DIR/$tdir)
+       local mdtidx=$($LFS getstripe -m $DIR/$tdir)
        local facet=mds$((mdtidx + 1))
        stat $DIR/$tdir
        set_nodes_failloc $(facet_active_host $facet) 0x80000160
@@ -3639,7 +3928,7 @@ test_80a() {
 
        echo "Finish migration, then checking.."
        for file in $(find $DIR1/$tdir); do
-               mdt_index=$($LFS getstripe -M $file)
+               mdt_index=$($LFS getstripe -m $file)
                [ $mdt_index == $MDTIDX ] ||
                        error "$file is not on MDT${MDTIDX}"
        done
@@ -3774,7 +4063,7 @@ test_80b() {
 }
 run_test 80b "Accessing directory during migration"
 
-test_81() {
+test_81a() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
 
        rm -rf $DIR1/$tdir
@@ -3800,7 +4089,35 @@ test_81() {
 
        return 0
 }
-run_test 81 "rename and stat under striped directory"
+run_test 81a "rename and stat under striped directory"
+
+test_81b() {
+       [ $MDSCOUNT -lt 2 ] &&
+               skip "We need at least 2 MDTs for this test"
+
+       local total
+       local setattr_pid
+
+       total=1000
+
+       $LFS mkdir -c $MDSCOUNT $DIR1/$tdir || error "$LFS mkdir"
+       createmany -o $DIR1/$tdir/$tfile. $total || error "createmany"
+
+       (
+               while true; do
+                       touch $DIR1/$tdir
+               done
+       ) &
+       setattr_pid=$!
+
+       for i in $(seq $total); do
+               mrename $DIR2/$tdir/$tfile.$i $DIR2/$tdir/$tfile-new.$i \
+                       > /dev/null
+       done
+
+       kill -9 $setattr_pid
+}
+run_test 81b "rename under striped directory doesn't deadlock"
 
 test_82() {
        [[ $(lustre_version_code $SINGLEMDS) -gt $(version_code 2.6.91) ]] ||
@@ -3970,10 +4287,10 @@ test_93() {
        #define OBD_FAIL_MDS_LOV_CREATE_RACE     0x163
        do_facet $SINGLEMDS "lctl set_param fail_loc=0x00000163"
 
-       $SETSTRIPE -c -1 $DIR1/$tfile-1/file1 &
+       $LFS setstripe -c -1 $DIR1/$tfile-1/file1 &
        local PID1=$!
        sleep 1
-       $SETSTRIPE -c -1 $DIR2/$tfile-2/file2 &
+       $LFS setstripe -c -1 $DIR2/$tfile-2/file2 &
        local PID2=$!
        wait $PID2
        wait $PID1
@@ -3981,11 +4298,11 @@ test_93() {
        do_facet $SINGLEMDS "lctl set_param -n \
                'lod.lustre-MDT*/qos_threshold_rr' $old_rr"
 
-       $GETSTRIPE $DIR1/$tfile-1/file1
-       rc1=$($GETSTRIPE -q $DIR1/$tfile-1/file1 |
+       $LFS getstripe $DIR1/$tfile-1/file1
+       rc1=$($LFS getstripe -q $DIR1/$tfile-1/file1 |
                awk '{if (/[0-9]/) print $1 }' | sort | uniq -d | wc -l)
-       $GETSTRIPE $DIR2/$tfile-2/file2
-       rc2=$($GETSTRIPE -q $DIR2/$tfile-2/file2 |
+       $LFS getstripe $DIR2/$tfile-2/file2
+       rc2=$($LFS getstripe -q $DIR2/$tfile-2/file2 |
                awk '{if (/[0-9]/) print $1 }' | sort | uniq -d | wc -l)
        echo "rc1=$rc1 and rc2=$rc2 "
        [ $rc1 -eq 0 ] && [ $rc2 -eq 0 ] ||
@@ -3993,6 +4310,196 @@ test_93() {
 }
 run_test 93 "alloc_rr should not allocate on same ost"
 
+# Data-on-MDT tests
+test_100a() {
+       skip "Reserved for glimpse-ahead" && return
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.10.55) ] &&
+               skip "Need MDS version at least 2.10.55" && return
+
+       mkdir -p $DIR/$tdir
+
+       $LFS setstripe -E 1024K -L mdt -E EOF $DIR/$tdir/dom
+
+       lctl set_param -n mdc.*.stats=clear
+       dd if=/dev/zero of=$DIR2/$tdir/dom bs=4096 count=1 || return 1
+
+       $CHECKSTAT -t file -s 4096 $DIR/$tdir/dom || error "stat #1"
+       # first stat from server should return size data and save glimpse
+       local gls=$(lctl get_param -n mdc.*.stats | grep -c ldlm_glimpse)
+       [ $gls -eq 0 ] || error "Unexpected $gls glimpse RPCs"
+       # second stat to check size is NOT cached on client without IO lock
+       $CHECKSTAT -t file -s 4096 $DIR/$tdir/dom || error "stat #2"
+
+       local gls=$(lctl get_param -n mdc.*.stats | grep -c ldlm_glimpse)
+       [ $gls -ge 1 ] || error "Expect glimpse RPCs but none"
+       rm -f $dom
+}
+run_test 100a "DoM: glimpse RPCs for stat without IO lock (DoM only file)"
+
+test_100b() {
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.10.55) ] &&
+               skip "Need MDS version at least 2.10.55" && return
+
+       mkdir -p $DIR/$tdir
+
+       $LFS setstripe -E 1024K -L mdt -E EOF $DIR/$tdir/dom
+
+       lctl set_param -n mdc.*.stats=clear
+       dd if=/dev/zero of=$DIR2/$tdir/dom bs=4096 count=1 || return 1
+       cancel_lru_locks mdc
+       # first stat data from server should have size
+       $CHECKSTAT -t file -s 4096 $DIR/$tdir/dom || error "stat #1"
+       # second stat to check size is cached on client
+       $CHECKSTAT -t file -s 4096 $DIR/$tdir/dom || error "stat #2"
+
+       local gls=$(lctl get_param -n mdc.*.stats | grep -c ldlm_glimpse)
+       # both stats should cause no glimpse requests
+       [ $gls == 0 ] || error "Unexpected $gls glimpse RPCs"
+       rm -f $dom
+}
+run_test 100b "DoM: no glimpse RPC for stat with IO lock (DoM only file)"
+
+test_100c() {
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.10.55) ] &&
+               skip "Need MDS version at least 2.10.55" && return
+
+       mkdir -p $DIR/$tdir
+
+       $LFS setstripe -E 1024K -L mdt -E EOF $DIR/$tdir/dom
+
+       lctl set_param -n mdc.*.stats=clear
+       lctl set_param -n osc.*.stats=clear
+       dd if=/dev/zero of=$DIR2/$tdir/dom bs=2048K count=1 || return 1
+
+       # check that size is merged from MDT and OST correctly
+       $CHECKSTAT -t file -s 2097152 $DIR/$tdir/dom ||
+               error "Wrong size from stat #1"
+
+       local gls=$(lctl get_param -n osc.*.stats | grep -c ldlm_glimpse)
+       [ $gls -eq 0 ] && error "Expect OST glimpse RPCs but got none"
+
+       rm -f $dom
+}
+run_test 100c "DoM: write vs stat without IO lock (combined file)"
+
+test_100d() {
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.10.55) ] &&
+               skip "Need MDS version at least 2.10.55" && return
+
+       mkdir -p $DIR/$tdir
+
+       $LFS setstripe -E 1024K -L mdt -E EOF $DIR/$tdir/dom
+
+
+       dd if=/dev/zero of=$DIR2/$tdir/dom bs=2048K count=1 || return 1
+       lctl set_param -n mdc.*.stats=clear
+       $TRUNCATE $DIR2/$tdir/dom 4096
+
+       # check that reported size is valid after file grows to OST and
+       # is truncated back to MDT stripe size
+       $CHECKSTAT -t file -s 4096 $DIR/$tdir/dom ||
+               error "Wrong size from stat #1"
+
+       local gls=$(lctl get_param -n osc.*.stats | grep -c ldlm_glimpse)
+       [ $gls -eq 0 ] && error "Expect OST glimpse but got none"
+
+       rm -f $dom
+}
+run_test 100d "DoM: write+truncate vs stat without IO lock (combined file)"
+
+test_101a() {
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.10.55) ] &&
+               skip "Need MDS version at least 2.10.55" && return
+
+       $LFS setstripe -E 1024K -L mdt -E EOF $DIR1/$tfile
+       # to get layout
+       $CHECKSTAT -t file $DIR1/$tfile
+
+       local old_wb=$(sysctl -n vm.dirty_writeback_centisecs)
+       sysctl -wq vm.dirty_writeback_centisecs=0
+
+       trap "sysctl -wq vm.dirty_writeback_centisecs=$old_wb" EXIT
+
+       # open + IO lock
+       dd if=/dev/zero of=$DIR1/$tfile bs=4096 count=1 ||
+               error_noexit "Write fails"
+       # must discard pages
+       lctl set_param -n mdc.*.stats=clear
+       rm $DIR2/$tfile || error "Unlink fails"
+
+       local writes=$(lctl get_param -n mdc.*.stats | grep -c ost_write)
+       [ $writes -eq 0 ] || error "Found WRITE RPC but expect none"
+}
+run_test 101a "Discard DoM data on unlink"
+
+test_101b() {
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.10.55) ] &&
+               skip "Need MDS version at least 2.10.55" && return
+
+       $LFS setstripe -E 1024K -L mdt -E EOF $DIR1/$tfile
+       touch $DIR1/${tfile}_2
+       # to get layout
+       $CHECKSTAT -t file $DIR1/$tfile
+
+       local old_wb=$(sysctl -n vm.dirty_writeback_centisecs)
+       sysctl -wq vm.dirty_writeback_centisecs=0
+
+       trap "sysctl -wq vm.dirty_writeback_centisecs=$old_wb" EXIT
+
+       # open + IO lock
+       dd if=/dev/zero of=$DIR1/$tfile bs=4096 count=1 || error "Write fails"
+       # must discard pages
+       lctl set_param -n mdc.*.stats=clear
+       mv $DIR2/${tfile}_2 $DIR2/$tfile || error "Rename fails"
+
+       local writes=$(lctl get_param -n mdc.*.stats | grep -c ost_write)
+       [ $writes -eq 0 ] || error "Found WRITE RPC but expect none"
+}
+run_test 101b "Discard DoM data on rename"
+
+test_101c() {
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.10.55) ] &&
+               skip "Need MDS version at least 2.10.55" && return
+
+       $LFS setstripe -E 1024K -L mdt -E EOF $DIR1/$tfile
+       # to get layout
+       $CHECKSTAT -t file $DIR1/$tfile
+
+       local old_wb=$(sysctl -n vm.dirty_writeback_centisecs)
+       sysctl -wq vm.dirty_writeback_centisecs=0
+
+       trap "sysctl -wq vm.dirty_writeback_centisecs=$old_wb" EXIT
+
+       # open + IO lock
+       dd if=/dev/zero of=$DIR1/$tfile bs=4096 count=1 || error "Write fails"
+       $MULTIOP $DIR1/$tfile O_c &
+       MULTIOP_PID=$!
+       sleep 1
+       lctl set_param -n mdc.*.stats=clear
+       rm $DIR2/$tfile > /dev/null || error "Unlink fails for opened file"
+       kill -USR1 $MULTIOP_PID && wait $MULTIOP_PID || error "multiop failure"
+
+       local writes=$(lctl get_param -n mdc.*.stats | grep -c ost_write)
+       [ $writes -eq 0 ] || error "Found WRITE RPC but expect none"
+}
+run_test 101c "Discard DoM data on close-unlink"
+
+# test to verify file handle related system calls
+# (name_to_handle_at/open_by_handle_at)
+# The new system calls are supported in glibc >= 2.14.
+
+# test to verify we can open by handle an unlinked file from > 1 client
+# This test opens the file normally on $DIR1, which is on one mount, and then
+# opens it by handle on $DIR2, which is on a different mount.
+test_102() {
+       echo "Test file_handle syscalls" > $DIR/$tfile ||
+               error "write failed"
+       check_fhandle_syscalls $DIR/$tfile $DIR2 ||
+               error "check_fhandle_syscalls failed"
+       rm -f $DIR2/$tfile
+}
+run_test 102 "Test open by handle of unlinked file"
+
 log "cleanup: ======================================================"
 
 # kill and wait in each test only guarentee script finish, but command in script